/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2010, Parrot Foundation.

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_bigint.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void maybe_throw_overflow_error(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC* upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

#define ASSERT_ARGS_maybe_throw_overflow_error __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_upgrade_self_to_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void maybe_throw_overflow_error(PARROT_INTERP)>

Checks to see if the interpreter is set to throw an exception on overflow.

If so, throw the exception, otherwise ignore.

=cut

*/

static void
maybe_throw_overflow_error(PARROT_INTERP)
{
    ASSERT_ARGS(maybe_throw_overflow_error)

    /* check to see what the behavior is. If the interpreter is set
       to throw an exception on overflow. If so, throw the exception,
       otherwise, chill out it's no big deal. */
    if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
}

/*

=item C<static PMC* upgrade_self_to_bignum(PARROT_INTERP, PMC *self)>

Returns a pointer of *self upgraded to a bignum

=cut

*/

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
{
    ASSERT_ARGS(upgrade_self_to_bignum)

    /* Do an in-place upgrade to a Bignum of SELF and return a pointer
       to it (which is probably redundant, but whatever). */
    const INTVAL a = VTABLE_get_integer(interp, self);
    Parrot_pmc_reuse(interp, self, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, self, a);
    return self;
}
#line 118 "./src/pmc/integer.c"
static  PMC  * Parrot_Integer_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  PMC * Parrot_Integer_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest);
static  PMC  * Parrot_Integer_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL Parrot_Integer_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL Parrot_Integer_cmp_num(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_decrement(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC * Parrot_Integer_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC * Parrot_Integer_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, SHIM(PMC *dest));
static  PMC  * Parrot_Integer_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, SHIM(PMC *dest));
static  void  Parrot_Integer_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  INTVAL  Parrot_Integer_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Integer_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Integer_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  * Parrot_Integer_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Integer_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Integer_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void Parrot_Integer_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_Integer_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_floor_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Integer_i_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_modulus_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_modulus_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void  Parrot_Integer_i_neg(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void  Parrot_Integer_increment(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL init);
static  void  Parrot_Integer_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init);
static  INTVAL  Parrot_Integer_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC * Parrot_Integer_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, SHIM(PMC *dest));
static  PMC  * Parrot_Integer_modulus_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, SHIM(PMC *dest));
static  PMC * Parrot_Integer_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest);
static  PMC  * Parrot_Integer_neg(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(PMC *dest));
static  void  Parrot_Integer_set_bool(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  PMC * Parrot_Integer_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest);
static  void  Parrot_Integer_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  PMC  * Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest));
static  PMC  * Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_String(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_Integer_nci_get_as_base(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_nci_set_random(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_decrement_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_i_add_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void Parrot_Integer_i_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_Integer_i_floor_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_floor_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_floor_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Integer_i_modulus_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_modulus_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_modulus_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_i_multiply_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void  Parrot_Integer_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_i_subtract_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b);
static  void  Parrot_Integer_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_init_orig(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Integer_init_int_orig(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL init);
static  void  Parrot_Integer_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init);
static  void  Parrot_Integer_set_bool_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Integer_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Integer_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Integer_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void  Parrot_Integer_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info);
static  void Parrot_Integer_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_add_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_add_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_add_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_subtract_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_subtract_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_subtract_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_multiply_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_multiply_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_multiply_String_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_floor_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_floor_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_modulus_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_modulus_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_modulus_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_i_modulus_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_String_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_num_String_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_num_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Integer_multi_cmp_num_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_Integer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP);
void    Parrot_Integer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Integer_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 1227 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);

    if (a != PARROT_INTVAL_MIN)
        return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
                                               abs(a));
    else {
        PMC *promoted;
        maybe_throw_overflow_error(interp);
        promoted = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_neg(interp, promoted, dest);
    }
#line 301 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_add_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_Complex:
            return Parrot_Integer_multi_add_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_BigInt:
            return Parrot_Integer_multi_add_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Integer_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest)
{
#line 385 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_add_int(interp, temp, b, dest);
    }
#line 350 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 146 "./src/pmc/integer.pmc"

    return Parrot_pmc_new_init_int(interp, _self->vtable->base_type,
        VTABLE_get_integer(interp, _self));
#line 359 "./src/pmc/integer.c"
}
static  INTVAL
Parrot_Integer_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_String(interp, _self, value);
            break;
        case enum_class_Float:
            return Parrot_Integer_multi_cmp_Float(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_cmp_DEFAULT(interp, _self, value);
            break;

    }
}
static  INTVAL
Parrot_Integer_cmp_num(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_num_String(interp, _self, value);
            break;
        case enum_class_Float:
            return Parrot_Integer_multi_cmp_num_Float(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_num", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_cmp_num_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Integer_decrement(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Integer_decrement_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC *
Parrot_Integer_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_divide_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC *
Parrot_Integer_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_floor_divide_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, SHIM(PMC *dest))
{
#line 844 "./src/pmc/integer.pmc"
    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    return Parrot_pmc_new_init_int(interp,
            VTABLE_type(interp, _self), (INTVAL)f);
#line 482 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, SHIM(PMC *dest))
{
#line 831 "./src/pmc/integer.pmc"
    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    return Parrot_pmc_new_init_int(interp,
           VTABLE_type(interp, _self), (INTVAL)f);
#line 497 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 1291 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->freeze(interp, _self, info);
    VTABLE_push_integer(interp, info, VTABLE_get_integer(interp, _self));
#line 506 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 231 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return iv ? 1 : 0;
#line 516 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 215 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return iv;
#line 526 "./src/pmc/integer.c"
}
static  FLOATVAL 
Parrot_Integer_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 247 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    return (FLOATVAL)iv;
#line 536 "./src/pmc/integer.c"
}
static  void  *
Parrot_Integer_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 161 "./src/pmc/integer.pmc"
    return &(PARROT_INTEGER(_self)->iv);
#line 543 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 269 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, _self));
#line 551 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 265 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, _self));
#line 559 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Integer_i_absolute_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Integer_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_add_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_i_add_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
Parrot_Integer_i_add_int_orig(interp, _self, b);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Integer_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_divide_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Integer_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_floor_divide_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_i_floor_divide_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Integer_i_floor_divide_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Integer_i_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_modulus_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_modulus_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_i_modulus_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_modulus_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Integer_i_modulus_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_multiply_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_i_multiply_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
Parrot_Integer_i_multiply_int_orig(interp, _self, b);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_neg(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Integer_i_neg_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Integer_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_i_subtract_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_i_subtract_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
Parrot_Integer_i_subtract_int_orig(interp, _self, b);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_increment(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Integer_increment_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Integer_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL init)
{
Parrot_Integer_init_int_orig(interp, _self, init);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init)
{
Parrot_Integer_init_pmc_orig(interp, _self, init);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  INTVAL 
Parrot_Integer_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1057 "./src/pmc/integer.pmc"

    INTVAL retval;

    switch (value->vtable->base_type) {
      case enum_class_BigInt:
      {
        PMC const *temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
            VTABLE_get_integer(interp, _self));
        Parrot_mmd_multi_dispatch_from_c_args(interp,
                "is_equal", "PP->I", temp, value, &retval);
        return retval;
      }
        break;
      default:
        return (VTABLE_get_integer(interp, _self)
            ==  VTABLE_get_integer(interp, value));
        break;
    }
#line 715 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_modulus_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_modulus_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, SHIM(PMC *dest))
{
#line 957 "./src/pmc/integer.pmc"
    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
            Parrot_util_intval_mod(VTABLE_get_integer(interp, _self), (INTVAL)value));
#line 751 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, SHIM(PMC *dest))
{
#line 946 "./src/pmc/integer.pmc"
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
            Parrot_util_intval_mod(VTABLE_get_integer(interp, _self), value));
#line 763 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_multiply_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_Complex:
            return Parrot_Integer_multi_multiply_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_BigInt:
            return Parrot_Integer_multi_multiply_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_String:
            return Parrot_Integer_multi_multiply_String_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest)
{
#line 663 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_multiply_int(interp, temp, b, dest);
    }
#line 816 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_neg(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(PMC *dest))
{
#line 1019 "./src/pmc/integer.pmc"
    const INTVAL a = VTABLE_get_integer(interp, _self);

    if (a != PARROT_INTVAL_MIN)
        return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
                                               -a);
    else {
        PMC *promoted;
        maybe_throw_overflow_error(interp);
        promoted = Parrot_pmc_new_init_int(interp, enum_class_BigInt, 0);
        return VTABLE_subtract_int(interp, promoted, a, promoted);
    }
#line 833 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bool(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Integer_set_bool_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Integer_set_integer_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Integer_set_number_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Integer_set_pmc_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Integer_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
Parrot_Integer_set_string_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC *
Parrot_Integer_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_subtract_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_Complex:
            return Parrot_Integer_multi_subtract_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_BigInt:
            return Parrot_Integer_multi_subtract_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Integer_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b, PMC *dest)
{
#line 528 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_subtract_int(interp, temp, b, dest);
    }
#line 912 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
Parrot_Integer_thaw_orig(interp, _self, info);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC  *
Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 339 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_add(interp, temp, value, dest);
    }
#line 938 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 356 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    dest           = Parrot_pmc_new_init_int(interp,
                        VTABLE_type(interp, value),
                        a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 953 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 368 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
            _self->vtable->get_integer(interp, _self));
    return VTABLE_add(interp, temp, value, dest);
#line 965 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 377 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));
    VTABLE_set_number_native(interp, dest,
        _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
    return dest;
#line 976 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 415 "./src/pmc/integer.pmc"

    Parrot_Integer_i_add_int(interp, _self, VTABLE_get_integer(interp, value));
#line 984 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 420 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    /**/UNUSED(a)

    Parrot_pmc_reuse(interp, _self, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
#line 997 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 430 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) + VTABLE_get_number(interp, value));
#line 1006 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 470 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_subtract(interp, temp, value, dest);
    }
#line 1026 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 487 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    dest           = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1042 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 500 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
             _self->vtable->get_integer(interp, _self));
    return VTABLE_subtract(interp, temp, value, dest);
#line 1054 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 509 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            _self->vtable->get_integer(interp, _self) - VTABLE_get_number(interp, value));
    return dest;
#line 1066 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 558 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_subtract(interp, _self, value);
    }
#line 1084 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 573 "./src/pmc/integer.pmc"

    const INTVAL a = _self->vtable->get_integer(interp, _self);

    Parrot_pmc_reuse(interp, _self, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, _self,
            (FLOATVAL)a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, _self, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1098 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 584 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, _self,
            _self->vtable->get_integer(interp, _self) - VTABLE_get_number(interp, value));
#line 1107 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 622 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL b  = VTABLE_get_integer(interp, value);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        return Parrot_pmc_new_init_int(interp,
                VTABLE_type(interp, _self), c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt, a);
        return VTABLE_multiply(interp, temp, value, dest);
    }
#line 1128 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 640 "./src/pmc/integer.pmc"

    return VTABLE_multiply(interp, value, _self, dest);
#line 1136 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 645 "./src/pmc/integer.pmc"

    return VTABLE_multiply_int(interp, value, _self->vtable->get_integer(interp, _self), dest);
#line 1144 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 650 "./src/pmc/integer.pmc"

    return Parrot_Integer_multi_multiply_Integer_PMC(interp, _self, value, dest);
#line 1152 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 655 "./src/pmc/integer.pmc"
    const FLOATVAL valf = VTABLE_get_number(interp, value);
    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
        _self->vtable->get_number(interp, _self) * valf);
#line 1161 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 746 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
        _self->vtable->get_integer(interp, _self));
    return VTABLE_divide(interp, temp, value, dest);
#line 1173 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 754 "./src/pmc/integer.pmc"
    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
                _self->vtable->get_number(interp, _self) / d);
#line 1187 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 767 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_divide(interp, _self, value);
#line 1197 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 774 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    VTABLE_set_number_native(interp, _self, _self->vtable->get_number(interp, _self) / d);
#line 1211 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 807 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
            _self->vtable->get_integer(interp, _self));
    return VTABLE_floor_divide(interp, temp, value, dest);
#line 1223 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 816 "./src/pmc/integer.pmc"
    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(_self->vtable->get_number(interp, _self) / d);
    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
        (INTVAL)f);
#line 1239 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 857 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_floor_divide(interp, _self, value);
#line 1249 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 863 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(_self->vtable->get_number(interp, _self) / d);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 1265 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 924 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new_init_int(interp, enum_class_BigInt,
         _self->vtable->get_integer(interp, _self));
    return VTABLE_modulus(interp, temp, value, dest);
#line 1277 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 933 "./src/pmc/integer.pmc"
    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    return Parrot_pmc_new_init_int(interp, VTABLE_type(interp, _self),
            Parrot_util_intval_mod(_self->vtable->get_integer(interp, _self), d));
#line 1291 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 968 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    _self = upgrade_self_to_bignum(interp, _self);
    VTABLE_i_modulus(interp, _self, value);
#line 1301 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 975 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            Parrot_util_intval_mod(_self->vtable->get_integer(interp, _self), d));
#line 1316 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_String(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1088 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);
    {
        const FLOATVAL fdiff =
            (FLOATVAL)iv - VTABLE_get_number(interp, value);

        if (FLOAT_IS_ZERO(fdiff)) {
            const INTVAL idiff =
                _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        }

        return fdiff > 0 ? 1 : -1;
    }
#line 1337 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1106 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, _self, iv);

    {
        const FLOATVAL diff = (FLOATVAL)iv - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    }
#line 1351 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1117 "./src/pmc/integer.pmc"

    /* int or undef */
    INTVAL selfint;
    GETATTR_Integer_iv(interp, _self, selfint);
    {
        const INTVAL valueint = VTABLE_get_integer(interp, value);
        return selfint > valueint ? 1 : selfint < valueint ? -1 : 0;
    }
#line 1365 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1138 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = _self->vtable->get_number(interp, _self) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1381 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1151 "./src/pmc/integer.pmc"

    const FLOATVAL diff = _self->vtable->get_number(interp, _self) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1390 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1157 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL diff = _self->vtable->get_integer(interp, _self) - VTABLE_get_integer(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1400 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_nci_get_as_base(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
INTVAL base;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &base);
    { /* BEGIN PMETHOD BODY */
#line 1266 "./src/pmc/integer.pmc"

    char buf[128];
    STRING *result;

    if ((base < 2) || (base > 36))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "get_as_base: base out of bounds");

    result = Parrot_str_from_int_base(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, _self),
            (unsigned int)base);

    #line 1427 "./src/pmc/integer.c"
    {
    /*BEGIN RETURN STRING *result */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *result */
    }
#line 1278 "./src/pmc/integer.pmc"

#line 1438 "./src/pmc/integer.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Integer_nci_set_random(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
INTVAL a;
INTVAL has_a;
INTVAL b;
INTVAL has_b;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIpIoIp",
            &_self, &a, &has_a, &b, &has_b);
    { /* BEGIN PMETHOD BODY */
#line 1328 "./src/pmc/integer.pmc"

    INTVAL r;
    if (has_a && a != 0) {
        if (!has_b) {
            if (a < 0)
                b = 0;
            if (a > 0) {
                b = a;
                a = 0;
            }
        }
        if (a == b || a > b) {
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "set_random: range start must be less than range end (%d, %d)", a, b);
        }
        {
            const double spread = (double)(b - a + 1);
            const double randpart = Parrot_util_float_rand(0);
            r = a + (INTVAL)(spread * randpart);
        }
    }
    else
        r = Parrot_util_int_rand(0);
    _self->vtable->set_integer_native(interp, _self, r);
#line 1487 "./src/pmc/integer.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_Integer_decrement_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1200 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - 1;

    if ((c^a) >= 0 || (c^~1) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        Parrot_pmc_reuse(interp, _self, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, _self, a);
        VTABLE_decrement(interp, _self);
    }
#line 1511 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1242 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);

    if (a != PARROT_INTVAL_MIN)
        VTABLE_set_integer_native(interp, _self, abs(a));
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_neg(interp, _self);
    }
#line 1527 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_add_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_add_Integer(interp, _self, value);
            break;
        case enum_class_Complex:
            Parrot_Integer_multi_i_add_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
            break;
        default:
            Parrot_Integer_multi_i_add_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Integer_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 450 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a + value);
#line 1559 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
#line 436 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_add_int(interp, _self, b);
    }
#line 1576 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_divide_BigInt(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
            break;
        default:
            Parrot_Integer_multi_i_divide_DEFAULT(interp, _self, value);
            break;

    }
}
static  void
Parrot_Integer_i_floor_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_floor_divide_BigInt(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", _self, value);
            break;
        default:
            Parrot_Integer_multi_i_floor_divide_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Integer_i_floor_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 888 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 1631 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_floor_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 876 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, _self) / value);
    VTABLE_set_integer_native(interp, _self, (INTVAL)f);
#line 1646 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_modulus_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_modulus_BigInt(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", _self, value);
            break;
        default:
            Parrot_Integer_multi_i_modulus_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Integer_i_modulus_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 997 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            Parrot_util_intval_mod(VTABLE_get_integer(interp, _self) , (INTVAL)value));
#line 1679 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_modulus_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 987 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, _self,
            Parrot_util_intval_mod(VTABLE_get_integer(interp, _self) , value));
#line 1692 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 694 "./src/pmc/integer.pmc"

    /*
    VTABLE_i_multiply_int(interp, _self, VTABLE_get_integer(interp, value));
    */
    VTABLE_set_number_native(interp, _self,
            VTABLE_get_integer(interp, _self) * VTABLE_get_number(interp, value));
#line 1704 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 718 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a * value);
#line 1713 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
#line 703 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, _self);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        upgrade_self_to_bignum(interp, _self);
        VTABLE_i_multiply_int(interp, _self, b);
    }
#line 1731 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1034 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);

    if (a != PARROT_INTVAL_MIN)
        VTABLE_set_integer_native(interp, _self, -a);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_set_integer_native(interp, _self, 0);
        VTABLE_i_subtract_int(interp, _self, a);
    }
#line 1748 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_subtract_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_subtract_Integer(interp, _self, value);
            break;
        case enum_class_Complex:
            Parrot_Integer_multi_i_subtract_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
            break;
        default:
            Parrot_Integer_multi_i_subtract_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Integer_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 604 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    VTABLE_set_number_native(interp, _self, a - value);
#line 1780 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL b)
{
#line 590 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, _self);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, _self, c);
    else {
        maybe_throw_overflow_error(interp);
        _self = upgrade_self_to_bignum(interp, _self);
        VTABLE_i_subtract_int(interp, _self, b);
    }
#line 1797 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1174 "./src/pmc/integer.pmc"

    INTVAL a, c;
    GETATTR_Integer_iv(interp, _self, a);
    c = a + 1;

    /* did not overflow */
    if ((c^a) >= 0 || (c^1) >= 0)
        SETATTR_Integer_iv(interp, _self, c);
    else {
        Parrot_pmc_reuse(interp, _self, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, _self, a);
        VTABLE_increment(interp, _self);
    }
#line 1816 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_orig(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 112 "./src/pmc/integer.pmc"
    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv      = 0;
#line 1826 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_int_orig(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL init)
{
#line 127 "./src/pmc/integer.pmc"
    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv = init;
#line 1836 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init)
{
#line 120 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(_self);

    attrs->iv      = VTABLE_get_integer(interp, init);
#line 1847 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bool_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 313 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self,
        Parrot_hll_get_ctx_HLL_type(interp, enum_class_Boolean), 0);
    VTABLE_set_bool(interp, _self, value);
#line 1857 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 284 "./src/pmc/integer.pmc"

    SETATTR_Integer_iv(interp, _self, value);
#line 1865 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 306 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self,
        Parrot_hll_get_ctx_HLL_type(interp, enum_class_Float), 0);
    VTABLE_set_number_native(interp, _self, value);
#line 1875 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 176 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, _self, VTABLE_get_integer(interp, value));
#line 1883 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 321 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, _self,
        Parrot_hll_get_ctx_HLL_type(interp, enum_class_String), 0);
    VTABLE_set_string_native(interp, _self, value);
#line 1893 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *info)
{
#line 1306 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->thaw(interp, _self, info);
    VTABLE_set_integer_native(interp, _self, VTABLE_shift_integer(interp, info));
#line 1902 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_add_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_add_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_add_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_add_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_add_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_add_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_add_Integer(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_add_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_add_Complex(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_add_DEFAULT(interp, _self, value);
}
static  void
Parrot_Integer_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_subtract_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_subtract_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_subtract_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_subtract_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_subtract_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_subtract_Integer(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_subtract_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_subtract_Complex(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_subtract_DEFAULT(interp, _self, value);
}
static  void
Parrot_Integer_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_multiply_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_multiply_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_multiply_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_multiply_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_multiply_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_multiply_String_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_multiply_String_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_divide_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_i_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_divide_BigInt(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_Integer_multi_floor_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_floor_divide_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_i_floor_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_floor_divide_BigInt(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_floor_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_Integer_multi_modulus_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_modulus_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_modulus_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Integer_multi_modulus_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Integer_multi_i_modulus_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_modulus_BigInt(interp, _self, value);
}
static  void
Parrot_Integer_multi_i_modulus_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Integer_multi_i_modulus_DEFAULT(interp, _self, value);
}
static  void
Parrot_Integer_multi_cmp_String_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_String(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Integer_multi_cmp_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_Float(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Integer_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Integer_multi_cmp_num_String_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_num_String(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Integer_multi_cmp_num_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_num_Float(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Integer_multi_cmp_num_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Integer_multi_cmp_num_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Integer_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->decrement = Parrot_Integer_decrement;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_pointer = Parrot_Integer_get_pointer;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->i_absolute = Parrot_Integer_i_absolute;
    vt->i_add = Parrot_Integer_i_add;
    vt->i_add_float = Parrot_Integer_i_add_float;
    vt->i_add_int = Parrot_Integer_i_add_int;
    vt->i_divide = Parrot_Integer_i_divide;
    vt->i_floor_divide = Parrot_Integer_i_floor_divide;
    vt->i_floor_divide_float = Parrot_Integer_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_Integer_i_floor_divide_int;
    vt->i_modulus = Parrot_Integer_i_modulus;
    vt->i_modulus_float = Parrot_Integer_i_modulus_float;
    vt->i_modulus_int = Parrot_Integer_i_modulus_int;
    vt->i_multiply = Parrot_Integer_i_multiply;
    vt->i_multiply_float = Parrot_Integer_i_multiply_float;
    vt->i_multiply_int = Parrot_Integer_i_multiply_int;
    vt->i_neg = Parrot_Integer_i_neg;
    vt->i_subtract = Parrot_Integer_i_subtract;
    vt->i_subtract_float = Parrot_Integer_i_subtract_float;
    vt->i_subtract_int = Parrot_Integer_i_subtract_int;
    vt->increment = Parrot_Integer_increment;
    vt->init = Parrot_Integer_init;
    vt->init_int = Parrot_Integer_init_int;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->neg = Parrot_Integer_neg;
    vt->set_bool = Parrot_Integer_set_bool;
    vt->set_integer_native = Parrot_Integer_set_integer_native;
    vt->set_number_native = Parrot_Integer_set_number_native;
    vt->set_pmc = Parrot_Integer_set_pmc;
    vt->set_string_native = Parrot_Integer_set_string_native;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->thaw = Parrot_Integer_thaw;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_pointer = Parrot_Integer_get_pointer;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->neg = Parrot_Integer_neg;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_get_vtable(interp);
    Parrot_Integer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_ro_get_vtable(interp);
    Parrot_Integer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Integer_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_scalar_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Integer"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Integer_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_scalar_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Integer")), PMCNULL);
    return isa;
}

void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iiv ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Integer_get_vtable(interp);
        vt->base_type      = enum_class_Integer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Integer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar integer");
        vt->isa_hash     = Parrot_Integer_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Integer_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Integer;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Integer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_as_base");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Integer_nci_get_as_base),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "set_random");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Integer_nci_set_random),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "Integer,Integer,PMC");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "Integer");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "Integer,Complex,PMC");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "Integer,BigInt,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "Integer,DEFAULT,PMC");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "Integer,Integer");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "Integer,Complex");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "Integer,DEFAULT");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "Integer,String,PMC");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "Integer,BigInt");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "floor_divide");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "i_floor_divide");
            STRING * const mfl_19 = CONST_STRING_GEN(interp, "modulus");
            STRING * const mfl_20 = CONST_STRING_GEN(interp, "i_modulus");
            STRING * const mfl_21 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_22 = CONST_STRING_GEN(interp, "Integer,String");
            STRING * const mfl_23 = CONST_STRING_GEN(interp, "Integer,Float");
            STRING * const mfl_24 = CONST_STRING_GEN(interp, "cmp_num");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_add_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_add_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_add_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_add_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_add_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_add_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_add_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_6, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_subtract_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_subtract_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_subtract_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_subtract_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_subtract_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_subtract_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_subtract_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_multiply_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_multiply_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_multiply_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_multiply_String_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_13, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_multiply_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_divide_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_divide_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_16, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_floor_divide_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_floor_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_floor_divide_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_16, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_floor_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_modulus_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_modulus_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_modulus_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_20, mfl_16, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_i_modulus_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_20, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_String_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_21, mfl_22, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_21, mfl_23, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_21, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_num_String_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_24, mfl_22, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_num_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_24, mfl_23, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Integer_multi_cmp_num_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_24, mfl_9, _temp_func);

        }
    } /* pass */
} /* Parrot_Integer_class_init */

#line 1352 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
