/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/parrotinterpreter.pmc"
/*
Copyright (C) 2001-2012, Parrot Foundation.

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/dynext.h"
#include "parrot/io.h"
#include "parrot/runcore_api.h"
#include "parrot/thread.h"
#include "pmc/pmc_class.h"
#include "pmc/pmc_sub.h"
#include "pmc/pmc_proxy.h"
#include "pmc/pmc_task.h"

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp
#define PMC_args(x)   ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->args
#define PMC_sub(x)    ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->sub

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void create_interp(
    ARGIN(PMC *self),
    ARGIN_NULLOK(Parrot_Interp parent))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_create_interp __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<PMC * clone_interpreter(Parrot_Interp s, INTVAL flags)>

Clones the interpreter as specified by the flags.

TODO: Move this logic into src/interp/api.c or src/threads.c, as appropriate

=cut

*/

PARROT_CANNOT_RETURN_NULL
PMC *
clone_interpreter(Parrot_Interp s, INTVAL flags)
{
    /* have to pass a parent to allocate_interpreter to prevent PMCNULL from being set to NULL */
    Parrot_Interp d = Parrot_interp_allocate_interpreter(s, flags);
    int stacktop;
    Parrot_GC_Init_Args args;

    PMC * interp_pmc;
    PMC * const s_config_hash = VTABLE_get_pmc_keyed_int(s, s->iglobals, IGLOBALS_CONFIG_HASH);

    memset(&args, 0, sizeof (args));
    args.stacktop = &stacktop;

    /* Set up the memory allocation system */
    Parrot_gc_initialize(d, &args);
    Parrot_block_GC_mark(d);
    Parrot_block_GC_sweep(d);

    d->ctx         = PMCNULL;
    d->resume_flag = RESUME_INITIAL;

    d->recursion_limit = RECURSION_LIMIT;

    /* PANIC will fail until this is done */
    d->piodata = NULL;
    Parrot_io_init(d);

    /*
     * Set up the string subsystem
     * This also generates the constant string tables
     * Do this before unsetting parent_interpreter to copy its hash_seed and constant string table
     */
    Parrot_str_init(d);

    /* create caches structure */
    init_object_cache(d);

    d->n_vtable_max = s->n_vtable_max;
    d->vtables = s->vtables;
    d->class_hash = Parrot_thread_create_proxy(s, d, s->class_hash);

    Parrot_cx_init_scheduler(d);

    d->parent_interpreter = NULL;

    /* create the root set registry */
    d->gc_registry = Parrot_pmc_new(d, enum_class_AddrRegistry);

    interp_pmc  = Parrot_pmc_new_noinit(d, enum_class_ParrotInterpreter);
    VTABLE_set_pointer(d, interp_pmc, d);

    /* init the interpreter globals array */
    d->iglobals = Parrot_pmc_new_init_int(d, enum_class_FixedPMCArray, (INTVAL)IGLOBALS_SIZE);

    VTABLE_set_pmc_keyed_int(d, d->iglobals, (INTVAL) IGLOBALS_INTERPRETER, interp_pmc);

    /* initialize built-in runcores */
    Parrot_runcore_init(d);

    /* create a proxy for the config_hash */
    VTABLE_set_pmc_keyed_int(d, d->iglobals, (INTVAL) IGLOBALS_CONFIG_HASH,
        Parrot_thread_create_proxy(s, d, s_config_hash));

    /* can't copy directly, unless you want double-frees */
    if (flags & PARROT_CLONE_RUNOPS)
        Parrot_runcore_switch(d, s->run_core->name);

    if (flags & PARROT_CLONE_INTERP_FLAGS) {
        /* XXX setting of IS_THREAD? */
        d->flags       = s->flags;
        d->debug_flags = s->debug_flags;
    }

    d->root_namespace = Parrot_thread_create_proxy(s, d, s->root_namespace);

    if (flags & PARROT_CLONE_HLL) {
        /* we'd like to share the HLL data. Give it a PMC_sync structure
           if it doesn't have one already */

        /* This used to be proxied:

            d->HLL_info = Parrot_thread_create_proxy(s, d, s->HLL_info);

            But src/hll.c:Parrot_hll_get_HLL_type() pokes directly into the
            PMC attributes which is a problem if we're using a Proxy. Instead,
            clone the structure so direct accesses continue working.
        */
        d->HLL_info = VTABLE_clone(d, s->HLL_info);
        d->HLL_namespace = Parrot_thread_create_proxy(s, d, s->HLL_namespace);
        d->HLL_entries   = Parrot_thread_create_proxy(s, d, s->HLL_entries);
    }

    if (flags & (PARROT_CLONE_LIBRARIES | PARROT_CLONE_CLASSES)) {
    }

    if (flags & PARROT_CLONE_LIBRARIES) {
        PMC * const s_pbc_libs = VTABLE_get_pmc_keyed_int(s, s->iglobals, IGLOBALS_PBC_LIBS);
        VTABLE_set_pmc_keyed_int(d, d->iglobals, (INTVAL) IGLOBALS_PBC_LIBS,
            Parrot_thread_create_proxy(s, d, s_pbc_libs));
    }

    create_initial_context(d);

    if (flags & PARROT_CLONE_CODE)
        Parrot_clone_code(d, s);

    /* setup stdio PMCs */
    Parrot_io_init(d);

    Parrot_unblock_GC_sweep(d);
    Parrot_unblock_GC_mark(d);

    return interp_pmc;
}


/*

=item C<static void create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(ARGIN(PMC *self), ARGIN_NULLOK(Parrot_Interp parent))
{
    ASSERT_ARGS(create_interp)
    Interp_flags flag  = PARROT_NO_FLAGS;
    Parrot_Interp new_interp;

    new_interp       = Parrot_interp_make_interpreter(parent, (INTVAL)flag);
    PMC_interp(self) = new_interp;

    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);
}
#line 230 "./src/pmc/parrotinterpreter.c"
static  PMC  * Parrot_ParrotInterpreter_clone(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_freeze(PARROT_INTERP, SHIM(PMC *_self), SHIM(PMC *info));
static  INTVAL  Parrot_ParrotInterpreter_get_integer(SHIM_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ParrotInterpreter_get_integer_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc(SHIM_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *key);
static  PMC  * Parrot_ParrotInterpreter_get_pmc_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  * Parrot_ParrotInterpreter_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent);
static  opcode_t  * Parrot_ParrotInterpreter_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next);
static  INTVAL Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val);
static  void  Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args);
static  void  Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value);
static  void Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(SHIM_INTERP, ARGMOD(PMC *_self), PMC *val);
static  INTVAL  Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  void Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stdin_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stdout_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_stderr_handle(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_getpid(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_current_task(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_schedule(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_nci_schedule_proxied(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ParrotInterpreter_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent);
static  void  Parrot_ParrotInterpreter_set_integer_keyed_int_orig(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val);
static  void  Parrot_ParrotInterpreter_set_pmc_orig(SHIM_INTERP, ARGMOD(PMC *_self), PMC *args);
static  void  Parrot_ParrotInterpreter_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *value);
static  void Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP);
void    Parrot_ParrotInterpreter_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ParrotInterpreter_clone(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 630 "./src/pmc/parrotinterpreter.pmc"
    PMC * const dest = clone_interpreter(PMC_interp(_self), PARROT_CLONE_DEFAULT);

    return dest;
#line 279 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 298 "./src/pmc/parrotinterpreter.pmc"

    if (PMC_data(_self)) {
        mem_gc_free(interp, PMC_data(_self));
        PMC_data(_self) = NULL;
    }
#line 290 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_freeze(PARROT_INTERP, SHIM(PMC *_self), SHIM(PMC *info))
{
#line 692 "./src/pmc/parrotinterpreter.pmc"
    Parrot_ex_throw_from_c_args(interp, NULL, 0,
            "Attempt to freeze interpreter");
#line 298 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 354 "./src/pmc/parrotinterpreter.pmc"

    const Parrot_Interp i = PMC_interp(_self);
    if (i->thread_data)
        return (INTVAL)i->thread_data->tid;
    return 0;
#line 309 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_get_integer_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 584 "./src/pmc/parrotinterpreter.pmc"
    Interp * const new_interp = PMC_interp(_self);

    if (key == -1)
        return (INTVAL)new_interp->flags;

    return Parrot_interp_info(new_interp, key);
#line 321 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 395 "./src/pmc/parrotinterpreter.pmc"
    return PMC_args(_self);
#line 328 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *key)
{
#line 465 "./src/pmc/parrotinterpreter.pmc"
    PMC    *nextkey;
    STRING *outer = NULL;
    STRING *item  = Parrot_key_string(interp, key);
    int     level = 0;

    PMC *ctx;

    if (STRING_equal(interp, item, CONST_STRING(interp, "globals")))
        return interp->root_namespace;

    if (STRING_equal(interp, item, CONST_STRING(interp, "packfile")))
        return Parrot_pf_get_current_packfile(interp);

    if (STRING_equal(interp, item, CONST_STRING(interp, "outer"))) {
        outer   = item;
        nextkey = Parrot_key_next(interp, key);

        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key  = nextkey;
            item = VTABLE_get_string(interp, key);
        }
    }

    nextkey = Parrot_key_next(interp, key);

    if (nextkey)
        level = VTABLE_get_integer(interp, nextkey);
    else if (outer)
        level = 1;

    if (level < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "No such caller depth");

    ctx = CURRENT_CONTEXT(interp);

    if (outer) {
        for (; level; --level) {
            ctx = Parrot_pcc_get_outer_ctx(interp, ctx);
            if (PMC_IS_NULL(ctx))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION, "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            PMC * const cont = Parrot_pcc_get_continuation(interp, ctx);

            if (PMC_IS_NULL(cont) || !PARROT_CONTINUATION(cont)->seg)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION, "No such caller depth");

            ctx = PARROT_CONTINUATION(cont)->to_ctx;

            if (PMC_IS_NULL(Parrot_pcc_get_sub(interp, ctx)))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION, "No such caller depth");
        }
    }

    if (item == outer)
        return Parrot_pcc_get_sub(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "context")))
        return ctx;

    if (STRING_equal(interp, item, CONST_STRING(interp, "sub")))
        return Parrot_pcc_get_sub(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "lexpad")))
        return Parrot_pcc_get_lex_pad(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "namespace")))
        return Parrot_pcc_get_namespace(interp, ctx);

    if (STRING_equal(interp, item, CONST_STRING(interp, "continuation")))
        return VTABLE_clone(interp, Parrot_pcc_get_continuation(interp, ctx));

    if (STRING_equal(interp, item, CONST_STRING(interp, "annotations"))) {
        PMC * const sub_pmc = Parrot_pcc_get_sub(interp, ctx);
        if (ctx == CURRENT_CONTEXT(interp)) {
            /* We can't know the current program counter for the currently
             * executing sub, so can't return annotations for that. */
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "Cannot get annotations at depth 0; use annotations op instead.");
        }
        if (!PMC_IS_NULL(sub_pmc)
        &&   sub_pmc->vtable->base_type == enum_class_Sub) {
            Parrot_Sub_attributes *sub;
            PackFile_ByteCode     *seg;
            opcode_t * const pc = Parrot_pcc_get_pc(interp, ctx);

            PMC_get_sub(interp, sub_pmc, sub);
            seg = sub->seg;

            if (sub->seg->annotations)
                return PackFile_Annotations_lookup(interp, seg->annotations,
                    pc - seg->base.data, NULL);
        }

        return Parrot_pmc_new(interp, enum_class_Hash);
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such item %Ss", item);
#line 439 "./src/pmc/parrotinterpreter.c"
}
static  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed_int(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 426 "./src/pmc/parrotinterpreter.pmc"
    Interp * const new_interp = PMC_interp(_self);

    if (key >= 0 && key < IGLOBALS_SIZE) {
        PMC * const val = VTABLE_get_pmc_keyed_int(new_interp,
                new_interp->iglobals, key);
        return val == NULL ? PMCNULL : val;
    }

    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->root_namespace;

    return PMCNULL;
#line 458 "./src/pmc/parrotinterpreter.c"
}
static  void  *
Parrot_ParrotInterpreter_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 339 "./src/pmc/parrotinterpreter.pmc"
    return PMC_interp(_self);
#line 465 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_ParrotInterpreter_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent)
{
Parrot_ParrotInterpreter_init_pmc_orig(interp, _self, parent);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  opcode_t  *
Parrot_ParrotInterpreter_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next)
{
#line 372 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(_self);

    /* TODO pass arguments from parent (interp) to child (new_interp) by
     * possibly clone of share the arguments r/o args can be passed as is */

    /* calculate offset and run */
    runops(new_interp, (size_t)((opcode_t *)PMC_sub(_self) -
        (opcode_t *)interp->code->base.data));

    return (opcode_t *)next;
#line 494 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL
Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_ParrotInterpreter:
            return Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val)
{
Parrot_ParrotInterpreter_set_integer_keyed_int_orig(interp, _self, key, val);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *args)
{
Parrot_ParrotInterpreter_set_pmc_orig(interp, _self, args);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value)
{
Parrot_ParrotInterpreter_set_pointer_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_ParrotInterpreter_nci_recursion_limit(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
INTVAL l;
INTVAL has_l;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &_self, &l, &has_l);
    { /* BEGIN PMETHOD BODY */
#line 235 "./src/pmc/parrotinterpreter.pmc"

    const INTVAL ret = interp->recursion_limit;
    UNUSED(_self)
    if (has_l)
        interp->recursion_limit = l;
    #line 557 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN INTVAL ret */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)ret);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL ret */
    }
#line 240 "./src/pmc/parrotinterpreter.pmc"

#line 568 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  INTVAL 
Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(SHIM_INTERP, ARGMOD(PMC *_self), PMC *val)
{
#line 650 "./src/pmc/parrotinterpreter.pmc"
    Parrot_Interp self  = PMC_interp(_self);
    Parrot_Interp other = PMC_interp(val);
    return self == other;
#line 584 "./src/pmc/parrotinterpreter.c"
}
static  INTVAL 
Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 657 "./src/pmc/parrotinterpreter.pmc"
    Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
            "ParrotInterpreter: no multiple dispatch variant 'is_equal' for %Ss",
            VTABLE_name(interp, value));
#line 594 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 699 "./src/pmc/parrotinterpreter.pmc"

    UNUSED(interp)
    Parrot_gc_mark_and_sweep(PMC_interp(_self), 0);
#line 611 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* core_type;
PMC* hll_type;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPP",
            &_self, &core_type, &hll_type);
    { /* BEGIN PMETHOD BODY */
#line 714 "./src/pmc/parrotinterpreter.pmc"

    const INTVAL core_type_id = VTABLE_type(interp, core_type);
    const INTVAL hll_type_id  = VTABLE_type(interp, hll_type);
    const INTVAL hll_id       = Parrot_pcc_get_HLL(interp, CURRENT_CONTEXT(interp));
    UNUSED(_self)
    Parrot_hll_register_HLL_type(interp, hll_id, core_type_id, hll_type_id);
#line 640 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_stdin_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* newhandle;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
    { /* BEGIN PMETHOD BODY */
#line 735 "./src/pmc/parrotinterpreter.pmc"

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDIN_FILENO, newhandle);
    UNUSED(_self)
    #line 665 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN PMC *handle */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
#line 738 "./src/pmc/parrotinterpreter.pmc"

#line 676 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_stdout_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* newhandle;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
    { /* BEGIN PMETHOD BODY */
#line 754 "./src/pmc/parrotinterpreter.pmc"

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDOUT_FILENO, newhandle);
    #line 700 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN PMC *handle */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
#line 756 "./src/pmc/parrotinterpreter.pmc"

#line 711 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_stderr_handle(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* newhandle;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPo",
            &_self, &newhandle);
    { /* BEGIN PMETHOD BODY */
#line 772 "./src/pmc/parrotinterpreter.pmc"

    PMC * const handle = Parrot_io_stdhandle(interp, PIO_STDERR_FILENO, newhandle);
    #line 735 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN PMC *handle */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
#line 774 "./src/pmc/parrotinterpreter.pmc"

#line 746 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_getpid(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 788 "./src/pmc/parrotinterpreter.pmc"

    const INTVAL id = Parrot_getpid();
    #line 769 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN INTVAL id */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)id);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL id */
    }
#line 790 "./src/pmc/parrotinterpreter.pmc"

#line 780 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_current_task(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 803 "./src/pmc/parrotinterpreter.pmc"

    Interp * const this_interp = PMC_interp(_self);
    PMC * const current_task = this_interp->cur_task;
    #line 804 "./src/pmc/parrotinterpreter.c"
    {
    /*BEGIN RETURN PMC *current_task */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)current_task);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *current_task */
    }
#line 806 "./src/pmc/parrotinterpreter.pmc"

#line 815 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_schedule(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* task;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &task);
    { /* BEGIN PMETHOD BODY */
#line 819 "./src/pmc/parrotinterpreter.pmc"

    Interp * const this_interp = PMC_interp(_self);
    Parrot_cx_schedule_immediate(this_interp, task);
#line 840 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ParrotInterpreter_nci_schedule_proxied(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* task;
PMC* proxy;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPP",
            &_self, &task, &proxy);
    { /* BEGIN PMETHOD BODY */
#line 834 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Proxy_attributes * const core_struct    = PARROT_PROXY(proxy);
    Interp                  * const proxied_interp = core_struct->interp;
    UNUSED(_self)

#ifdef PARROT_HAS_THREADS
    /* don't run GC from the wrong thread since GC involves stack walking and we
     * don't want the foreign GC to find our objects */
    Parrot_block_GC_mark_locked(proxied_interp);

    Parrot_cx_schedule_immediate(proxied_interp,
        Parrot_thread_create_local_task(interp, proxied_interp, task));

    Parrot_unblock_GC_mark_locked(proxied_interp);
#else
    Parrot_cx_schedule_immediate(interp, task);
#endif
#line 880 "./src/pmc/parrotinterpreter.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_ParrotInterpreter_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 253 "./src/pmc/parrotinterpreter.pmc"

    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
    }
    if (!PMC_interp(_self))
        create_interp(_self, interp);
    PObj_custom_destroy_SET(_self);
#line 902 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *parent)
{
#line 276 "./src/pmc/parrotinterpreter.pmc"

    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
    }
    if (!PMC_interp(_self))
        create_interp(_self, PMC_interp(parent));
    PObj_custom_destroy_SET(_self);
#line 917 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_integer_keyed_int_orig(SHIM_INTERP, ARGMOD(PMC *_self), INTVAL key, INTVAL val)
{
#line 604 "./src/pmc/parrotinterpreter.pmc"
    Interp * const new_interp = PMC_interp(_self);

    /* set interpreter flags */
    if (key == -1) {
        const INTVAL allowed = PARROT_BOUNDS_FLAG | PARROT_PROFILE_FLAG |
                         PARROT_GC_DEBUG_FLAG;
        Parrot_interp_clear_flag(new_interp, allowed);
        Parrot_interp_set_flag(new_interp, val & allowed);
    }
#line 932 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_pmc_orig(SHIM_INTERP, ARGMOD(PMC *_self), PMC *args)
{
#line 410 "./src/pmc/parrotinterpreter.pmc"
    PMC_args(_self) = args;
#line 939 "./src/pmc/parrotinterpreter.c"
}
static  void 
Parrot_ParrotInterpreter_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *value)
{
#line 316 "./src/pmc/parrotinterpreter.pmc"

    /* XXX: init_world in src/global_setup.c needs to create a
     * ParrotInterpreter through Parrot_pmc_new_noinit.  If this PMC hasn't been
     * initialized, cheat by initializing instead. */
    if (!PMC_data(_self)) {
        Parrot_ParrotInterpreter_attributes * const attrs =
            mem_gc_allocate_zeroed_typed(interp, Parrot_ParrotInterpreter_attributes);
        PMC_data(_self) = attrs;
        PObj_custom_destroy_SET(_self);
    }
    PMC_interp(_self) = (struct parrot_interp_t *)value;
#line 956 "./src/pmc/parrotinterpreter.c"
}
static  void
Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *val;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &val);
_result = Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter(interp, _self, val);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_ParrotInterpreter_multi_is_equal_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->freeze = Parrot_ParrotInterpreter_freeze;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->init = Parrot_ParrotInterpreter_init;
    vt->init_pmc = Parrot_ParrotInterpreter_init_pmc;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->set_integer_keyed_int = Parrot_ParrotInterpreter_set_integer_keyed_int;
    vt->set_pmc = Parrot_ParrotInterpreter_set_pmc;
    vt->set_pointer = Parrot_ParrotInterpreter_set_pointer;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ParrotInterpreter_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ParrotInterpreter_clone;
    vt->destroy = Parrot_ParrotInterpreter_destroy;
    vt->freeze = Parrot_ParrotInterpreter_freeze;
    vt->get_integer = Parrot_ParrotInterpreter_get_integer;
    vt->get_integer_keyed_int = Parrot_ParrotInterpreter_get_integer_keyed_int;
    vt->get_pmc = Parrot_ParrotInterpreter_get_pmc;
    vt->get_pmc_keyed = Parrot_ParrotInterpreter_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ParrotInterpreter_get_pmc_keyed_int;
    vt->get_pointer = Parrot_ParrotInterpreter_get_pointer;
    vt->invoke = Parrot_ParrotInterpreter_invoke;
    vt->is_equal = Parrot_ParrotInterpreter_is_equal;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_ParrotInterpreter_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotInterpreter_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_ParrotInterpreter_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ParrotInterpreter_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ParrotInterpreter"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ParrotInterpreter_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ParrotInterpreter")), PMCNULL);
    return isa;
}

void
Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ParrotInterpreter_get_vtable(interp);
        vt->base_type      = enum_class_ParrotInterpreter;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ParrotInterpreter");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_ParrotInterpreter_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ParrotInterpreter_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ParrotInterpreter;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ParrotInterpreter_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "recursion_limit");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_recursion_limit),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "run_gc");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_run_gc),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "hll_map");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_hll_map),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stdin_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stdin_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stdout_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stdout_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "stderr_handle");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_stderr_handle),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "getpid");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_getpid),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "current_task");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_current_task),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "schedule");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_schedule),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "schedule_proxied");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_schedule_proxied),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "is_equal");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "ParrotInterpreter,ParrotInterpreter");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "ParrotInterpreter");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "ParrotInterpreter,DEFAULT");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_ParrotInterpreter_multi_is_equal_ParrotInterpreter_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_ParrotInterpreter_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

        }
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */

#line 852 "./src/pmc/parrotinterpreter.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
