/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablefloatarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablefloatarray.h"
#include "pmc_fixedfloatarray.h"
#include "pmc_default.h"
#include "resizablefloatarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizablefloatarray.pmc"
/*
Copyright (C) 2001-2011, Parrot Foundation.

=head1 NAME

src/pmc/resizablefloatarray.pmc - resizable array for floating point
numbers only

=head1 DESCRIPTION

This class, C<ResizableFloatArray>, implements an array of resizable size,
which stores FLOATVALs. It uses Float PMCs to do all necessary conversions.

=head2 Functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 48 "./src/pmc/resizablefloatarray.c"
static  PMC  * Parrot_ResizableFloatArray_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_ResizableFloatArray_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  FLOATVAL  Parrot_ResizableFloatArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableFloatArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizableFloatArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  void  Parrot_ResizableFloatArray_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value);
static  FLOATVAL  Parrot_ResizableFloatArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableFloatArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  FLOATVAL  Parrot_ResizableFloatArray_pop_float_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableFloatArray_push_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizableFloatArray_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  void  Parrot_ResizableFloatArray_set_number_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value);
static  FLOATVAL  Parrot_ResizableFloatArray_shift_float_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizableFloatArray_unshift_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
void    Parrot_ResizableFloatArray_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableFloatArray_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableFloatArray_get_vtable(PARROT_INTERP);
void    Parrot_ResizableFloatArray_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ResizableFloatArray_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ResizableFloatArray_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_ResizableFloatArray_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 152 "./src/pmc/resizablefloatarray.pmc"

    INTVAL size;
    PMC * const copy = interp->vtables[enum_class_FixedFloatArray]->clone(interp, _self);

    /* copy trimmed extra space */
    GETATTR_ResizableFloatArray_size(interp, _self, size);
    SETATTR_ResizableFloatArray_resize_threshold(interp, copy, size);

    return copy;
#line 82 "./src/pmc/resizablefloatarray.c"
}
static  FLOATVAL 
Parrot_ResizableFloatArray_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 39 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL *float_array;
    INTVAL    size;

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableFloatArray: index out of bounds!");

    GETATTR_ResizableFloatArray_size(interp, _self, size);
    if (key >= size)
        return 0.0;

    GETATTR_ResizableFloatArray_float_array(interp, _self, float_array);
    return float_array[key];
#line 102 "./src/pmc/resizablefloatarray.c"
}
static  FLOATVAL 
Parrot_ResizableFloatArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
FLOATVAL  result;
result = Parrot_ResizableFloatArray_pop_float_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
return result;}
static  void 
Parrot_ResizableFloatArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_ResizableFloatArray_push_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ResizableFloatArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
Parrot_ResizableFloatArray_set_integer_native_orig(interp, _self, size);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_ResizableFloatArray_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value)
{
Parrot_ResizableFloatArray_set_number_keyed_int_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  FLOATVAL 
Parrot_ResizableFloatArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
FLOATVAL  result;
result = Parrot_ResizableFloatArray_shift_float_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
return result;}
static  void 
Parrot_ResizableFloatArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_ResizableFloatArray_unshift_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  FLOATVAL 
Parrot_ResizableFloatArray_pop_float_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 188 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL value;
    INTVAL size;
    GETATTR_ResizableFloatArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableFloatArray: Can't pop from an empty array!");

    value = VTABLE_get_number_keyed_int(interp, _self, size-1);
    VTABLE_set_integer_native(interp, _self, size - 1);
    return value;
#line 158 "./src/pmc/resizablefloatarray.c"
}
static  void 
Parrot_ResizableFloatArray_push_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 173 "./src/pmc/resizablefloatarray.pmc"

    const INTVAL nextix = VTABLE_elements(interp, _self);
    VTABLE_set_number_keyed_int(interp, _self, nextix, value);
#line 167 "./src/pmc/resizablefloatarray.c"
}
static  void 
Parrot_ResizableFloatArray_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 99 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL *float_array;
    INTVAL    resize_threshold;

    if (size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableFloatArray: Can't resize to negative value!");

    GETATTR_ResizableFloatArray_float_array(interp, _self, float_array);
    GETATTR_ResizableFloatArray_resize_threshold(interp, _self, resize_threshold);
    if (!float_array) {
        /* empty - used fixed routine */
        if (size < 8) {
            interp->vtables[enum_class_FixedFloatArray]->set_integer_native(interp, _self, 8);
            SETATTR_ResizableFloatArray_size(interp, _self, size);
            SETATTR_ResizableFloatArray_resize_threshold(interp, _self, 8);
        }
        else {
            interp->vtables[enum_class_FixedFloatArray]->set_integer_native(interp, _self, size);
            SETATTR_ResizableFloatArray_resize_threshold(interp, _self, size);
        }
    }
    else if (size <= resize_threshold){
        /* we could shrink here if necessary */
        SETATTR_ResizableFloatArray_size(interp, _self, size);
        return;
    }
    else {
        INTVAL cur = resize_threshold;
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            const INTVAL needed = size - cur;
            cur          += needed + 4096;
            cur          &= ~0xfff;
        }
        SETATTR_ResizableFloatArray_float_array(interp, _self,
                mem_gc_realloc_n_typed(interp, float_array, cur, FLOATVAL));
        SETATTR_ResizableFloatArray_size(interp, _self, size);
        SETATTR_ResizableFloatArray_resize_threshold(interp, _self, cur);
    }
#line 214 "./src/pmc/resizablefloatarray.c"
}
static  void 
Parrot_ResizableFloatArray_set_number_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL value)
{
#line 66 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL *float_array;
    INTVAL    size;

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableFloatArray: index out of bounds!");

    GETATTR_ResizableFloatArray_size(interp, _self, size);
    if (key >= size)
        VTABLE_set_integer_native(interp, _self, key+1);

    GETATTR_ResizableFloatArray_float_array(interp, _self, float_array);
    float_array[key] = value;
#line 234 "./src/pmc/resizablefloatarray.c"
}
static  FLOATVAL 
Parrot_ResizableFloatArray_shift_float_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 211 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL value, *float_array;
    INTVAL size;

    GETATTR_ResizableFloatArray_size(interp, _self, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableFloatArray: Can't shift from an empty array!");

    GETATTR_ResizableFloatArray_float_array(interp, _self, float_array);
    value             = float_array[0];
    SETATTR_ResizableFloatArray_size(interp, _self, --size);

    memmove(float_array, float_array + 1, size * sizeof (FLOATVAL));
    return value;
#line 256 "./src/pmc/resizablefloatarray.c"
}
static  void 
Parrot_ResizableFloatArray_unshift_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 239 "./src/pmc/resizablefloatarray.pmc"

    INTVAL    size;
    FLOATVAL *float_array;

    GETATTR_ResizableFloatArray_size(interp, _self, size);
    VTABLE_set_integer_native(interp, _self, size + 1);
    GETATTR_ResizableFloatArray_float_array(interp, _self, float_array);
    memmove(float_array + 1, float_array, size * sizeof (FLOATVAL));
    float_array[0] = value;
#line 271 "./src/pmc/resizablefloatarray.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizableFloatArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizableFloatArray_clone;
    vt->get_number_keyed_int = Parrot_ResizableFloatArray_get_number_keyed_int;
    vt->pop_float = Parrot_ResizableFloatArray_pop_float;
    vt->push_float = Parrot_ResizableFloatArray_push_float;
    vt->set_integer_native = Parrot_ResizableFloatArray_set_integer_native;
    vt->set_number_keyed_int = Parrot_ResizableFloatArray_set_number_keyed_int;
    vt->shift_float = Parrot_ResizableFloatArray_shift_float;
    vt->unshift_float = Parrot_ResizableFloatArray_unshift_float;
    vt->attr_size = sizeof(Parrot_ResizableFloatArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizableFloatArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizableFloatArray_clone;
    vt->get_number_keyed_int = Parrot_ResizableFloatArray_get_number_keyed_int;
    vt->attr_size = sizeof(Parrot_ResizableFloatArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableFloatArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedFloatArray_get_vtable(interp);
    Parrot_ResizableFloatArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizableFloatArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedFloatArray_ro_get_vtable(interp);
    Parrot_ResizableFloatArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizableFloatArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedFloatArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ResizableFloatArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizableFloatArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedFloatArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizableFloatArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizableFloatArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :float_array Iresize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizableFloatArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizableFloatArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizableFloatArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizableFloatArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ResizableFloatArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ResizableFloatArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizableFloatArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableFloatArray_class_init */

#line 249 "./src/pmc/resizablefloatarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
