/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/stringhandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_stringhandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "stringhandle.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/stringhandle.pmc"
/*
Copyright (C) 2008-2011, Parrot Foundation.

=head1 NAME

src/pmc/stringhandle.pmc - StringHandle PMC

=head1 DESCRIPTION

The StringHandle PMC performs I/O operations, but on an internal string rather
than an external file. Commonly used as a mock FileHandle for testing.

=cut

*/

#include "../src/io/io_private.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_encoding_is_utf8 __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=head2 Internal Functions

=over 4

=item C<static int encoding_is_utf8(PARROT_INTERP, const STRING *s)>

Helper function for internal usage. Return 1 if the string argument is
not null and has utf8 encoding, 0 otherwise.

=back

=cut

*/

PARROT_INLINE
static int
encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
{
    ASSERT_ARGS(encoding_is_utf8)
    if (STRING_IS_NULL(s))
        return 0;
    else
        return STRING_equal(interp, s, CONST_STRING(interp, "utf8"));
}
#line 83 "./src/pmc/stringhandle.c"
static  PMC  * Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_StringHandle_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP);
void    Parrot_StringHandle_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 110 "./src/pmc/stringhandle.pmc"

    const Parrot_StringHandle_attributes * const old_struct  = PARROT_STRINGHANDLE(_self);
    PMC * const copy = Parrot_pmc_new(interp, enum_class_StringHandle);
    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(copy);

    data_struct->stringhandle = old_struct->stringhandle;
    data_struct->mode     = old_struct->mode;
    data_struct->encoding = old_struct->encoding;
    data_struct->flags    = old_struct->flags;

    return copy;
#line 122 "./src/pmc/stringhandle.c"
}
static  INTVAL 
Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 154 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        return 0;

    return 1;
#line 136 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_StringHandle_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 133 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(_self);
    Parrot_gc_mark_STRING_alive(interp, data_struct->stringhandle);
    Parrot_gc_mark_STRING_alive(interp, data_struct->mode);
    Parrot_gc_mark_STRING_alive(interp, data_struct->encoding);
    Parrot_gc_mark_STRING_alive(interp, data_struct->filename);
    Parrot_gc_mark_STRING_alive(interp, data_struct->record_separator);
    Parrot_io_buffer_mark(interp, data_struct->read_buffer);
    Parrot_io_buffer_mark(interp, data_struct->write_buffer);
#line 157 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* filename;
INTVAL got_filename;
STRING* mode;
INTVAL got_mode;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIpSoIp",
            &_self, &filename, &got_filename, &mode, &got_mode);
    { /* BEGIN PMETHOD BODY */
#line 183 "./src/pmc/stringhandle.pmc"

    STRING *open_mode, *old_string;
    PMC * handle;
    INTVAL flags;

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_StringHandle_mode(interp, _self, mode);

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_StringHandle_filename(interp, _self, filename);

    handle = Parrot_io_open(interp, _self, filename, mode);

    #line 188 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN PMC *handle */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)handle);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *handle */
    }
#line 196 "./src/pmc/stringhandle.pmc"

#line 199 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 210 "./src/pmc/stringhandle.pmc"

    const INTVAL closed = Parrot_io_is_closed(interp, _self);
    #line 222 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL closed */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)closed);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL closed */
    }
#line 212 "./src/pmc/stringhandle.pmc"

#line 233 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* name;
INTVAL got_name;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &name, &got_name);
    { /* BEGIN PMETHOD BODY */
#line 227 "./src/pmc/stringhandle.pmc"

    STRING * const string_result = Parrot_io_readall_s(interp, _self);
    #line 258 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN STRING *string_result */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)string_result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *string_result */
    }
#line 229 "./src/pmc/stringhandle.pmc"

#line 269 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 242 "./src/pmc/stringhandle.pmc"

    Parrot_io_flush(interp, _self);
#line 292 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* to_print;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &to_print);
    { /* BEGIN PMETHOD BODY */
#line 257 "./src/pmc/stringhandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);
    Parrot_io_write_s(interp, _self, string_to_print);
#line 317 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* to_print;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &to_print);
    { /* BEGIN PMETHOD BODY */
#line 272 "./src/pmc/stringhandle.pmc"

    const INTVAL status = Parrot_io_write_s(interp, _self, to_print);
    #line 341 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL status */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL status */
    }
#line 274 "./src/pmc/stringhandle.pmc"

#line 352 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* new_type;
INTVAL got_type;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &new_type, &got_type);
    { /* BEGIN PMETHOD BODY */
#line 288 "./src/pmc/stringhandle.pmc"

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    GETATTR_StringHandle_flags(interp, _self, flags);

    if (got_type) {
        if (STRING_equal(interp, new_type, nobuffer_string)) {
            flags &= ~ PIO_BF_LINEBUF;
            flags &= ~ PIO_BF_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, linebuffer_string)) {
            flags |=   PIO_BF_LINEBUF;
            flags &= ~ PIO_BF_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, fullbuffer_string)) {
            flags &= ~ PIO_BF_LINEBUF;
            flags |=   PIO_BF_BLKBUF;
        }

        SETATTR_StringHandle_flags(interp, _self, flags);
    }

    if (flags & PIO_BF_LINEBUF)
        #line 401 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN STRING *linebuffer_string */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)linebuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *linebuffer_string */
    }
#line 314 "./src/pmc/stringhandle.pmc"

    else if (flags & PIO_BF_BLKBUF)
        #line 413 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)fullbuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *fullbuffer_string */
    }
#line 316 "./src/pmc/stringhandle.pmc"

    #line 424 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN STRING *nobuffer_string */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)nobuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *nobuffer_string */
    }
#line 317 "./src/pmc/stringhandle.pmc"

#line 435 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
INTVAL new_size;
INTVAL got_size;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &_self, &new_size, &got_size);
    { /* BEGIN PMETHOD BODY */
#line 330 "./src/pmc/stringhandle.pmc"

    INTVAL buffer_size;
    STRING *stringhandle;

    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle)) {
        if (got_size) {
            stringhandle = Parrot_str_new_noinit(interp, new_size);
            SETATTR_StringHandle_stringhandle(interp, _self, stringhandle);
        }
        else {
            #line 470 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL 0 */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 342 "./src/pmc/stringhandle.pmc"

        }
    }
    buffer_size = stringhandle->_buflen;

    #line 485 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL buffer_size */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)buffer_size);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL buffer_size */
    }
#line 347 "./src/pmc/stringhandle.pmc"


#line 497 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 361 "./src/pmc/stringhandle.pmc"

    STRING *mode;
    GETATTR_StringHandle_mode(interp, _self, mode);
    #line 521 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN STRING *mode */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)mode);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *mode */
    }
#line 364 "./src/pmc/stringhandle.pmc"

#line 532 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 378 "./src/pmc/stringhandle.pmc"

    const INTVAL is_eof = Parrot_io_eof(interp, _self);
    #line 555 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL 0 */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 380 "./src/pmc/stringhandle.pmc"

#line 566 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 395 "./src/pmc/stringhandle.pmc"

    UNUSED(interp);
    #line 589 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL -1 */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)-1);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL -1 */
    }
#line 397 "./src/pmc/stringhandle.pmc"

#line 600 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_StringHandle_nci_close(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 410 "./src/pmc/stringhandle.pmc"

    const INTVAL status = Parrot_io_close(interp, _self, 0);
    #line 623 "./src/pmc/stringhandle.c"
    {
    /*BEGIN RETURN INTVAL status */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL status */
    }
#line 412 "./src/pmc/stringhandle.pmc"

#line 634 "./src/pmc/stringhandle.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_StringHandle_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 81 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct =
            (Parrot_StringHandle_attributes *) PMC_data(_self);

    data_struct->flags        = 0;
    data_struct->stringhandle = NULL;
    data_struct->mode         = NULL;
    data_struct->encoding     = STRINGNULL;
    data_struct->filename     = NULL;
    data_struct->read_offset  = 0;
    data_struct->io_vtable    = (IO_VTABLE *)Parrot_io_get_vtable(interp,
                                                                IO_VTABLE_STRINGHANDLE, NULL);
    data_struct->read_buffer  = NULL;
    data_struct->write_buffer = NULL;
    data_struct->record_separator = CONST_STRING(interp, "\n");

    PObj_custom_mark_SET(_self);
#line 664 "./src/pmc/stringhandle.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StringHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_StringHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_StringHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StringHandle_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "StringHandle"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StringHandle_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Handle_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StringHandle")), PMCNULL);
    return isa;
}

void
Parrot_StringHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Srecord_separator :io_vtable :read_buffer :write_buffer Sencoding Iflags Sstringhandle Smode Sfilename Iread_offset ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StringHandle_get_vtable(interp);
        vt->base_type      = enum_class_StringHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StringHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StringHandle_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_StringHandle_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_StringHandle;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StringHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_closed");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_is_closed),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "readall");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_readall),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "flush");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_flush),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "print");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_print),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "puts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_puts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_type),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mode");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_mode),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "eof");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_eof),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_fd");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_get_fd),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "close");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_close),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_StringHandle_class_init */

#line 423 "./src/pmc/stringhandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
